#include "AppEvent.ch"

#include "Dbfdbe.ch"
#include "Ntxdbe.ch"
#include "Foxdbe.ch"
#include "Cdxdbe.ch"

#define MSG_DBFDBE_NOT_LOADED   "Database-Engine DBFDBE nicht geladen"
#define MSG_NTXDBE_NOT_LOADED   "Database-Engine NTXDBE nicht geladen"
#define MSG_DBFNTX_NOT_CREATED  "DBFNTX Database-Engine;konnte nicht erzeugt werden"

#pragma Library( "XppUI2.LIB" )
#pragma Library( "Adac20b.lib" )

PROCEDURE dbeSys()

   SET COLLATION TO GERMAN
   SET DATE TO GERMAN

   IF !DbeLoad( "DBFDBE", .T. )
      ALERT( MSG_DBFDBE_NOT_LOADED, { "OK" } )
   ENDIF
   IF !DbeLoad( "NTXDBE", .T. )
      ALERT( MSG_DBFDBE_NOT_LOADED, { "OK" } )
   ENDIF
   IF !DbeBuild( "DBFNTX", "DBFDBE", "NTXDBE" )
      ALERT( MSG_DBFNTX_NOT_CREATED, { "OK" } )
   ENDIF

   IF !DbeLoad( "CDXDBE", .T. )
      ALERT( "Database-Engine CDXDBE nicht geladen", { "OK" } )
   ENDIF
   IF !DbeLoad( "FOXDBE", .T. )
      ALERT( "Database-Engine FOXDBE nicht geladen", { "OK" } )
   ENDIF
   IF !DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
      ALERT( "FOXCDX Database-Engine;konnte nicht erzeugt werden", { "OK" } )
   ENDIF

   // visual FoxPro
*   DbeInfo( COMPONENT_DATA, FOXDBE_CREATE_2X, .F. )
*   DbeInfo( COMPONENT_DATA, FOXDBE_LOCKMODE , FOXDBE_LOCKMODE_VISUAL )
   //
*   DbeInfo( COMPONENT_ORDER, CDXDBE_MODE, CDXDBE_VFOXPRO )

   // using Cl*pper Comix/SixDrive
   //
   DbeInfo( COMPONENT_DATA, FOXDBE_CREATE_2X, .T. )
   DbeInfo( COMPONENT_DATA, FOXDBE_LOCKMODE, FOXDBE_LOCKMODE_CLIPPER )
   //
   DbeInfo( COMPONENT_ORDER, CDXDBE_MODE, CDXDBE_FOXPRO2X )

   // CDX as default
   //
   DbeSetDefault( "FOXCDX" )

RETURN


PROCEDURE Appsys
RETURN

PROCEDURE MAIN
LOCAL x
LOCAL nEvent, mp1, mp2, oXbp
LOCAL oDlg

   // diese Zeile macht dann Problem bei SEEK()
   //
   SET CHARSET TO ansi

   oDlg         := XbpDialog():new( ,, {0,0}, {800,600} )
   oDlg:title   := "Parent is Application Window"
   oDlg:tasklist := .T.
   oDlg:create()

   CenterControl(oDlg)
   oDlg:drawingArea:SetFontCompoundName( "14.Helv" )

   * ----------------------------------------------------------- *

   dbCreate( "__ANSI", {{ "NUM", "N", 3, 0},{ "CHAR", "C", 3, 0}})
   USE __ANSI EXCLUSIVE NEW

   // throw in all possible chars
   FOR x := 1 TO 255
      dbAppend()
      __ANSI->NUM  := x
      __ANSI->CHAR := CHR( x)
   NEXT

   // index it ...
   INDEX ON __ANSI->Char TO __ANSI
   SEEK("")

   * ----------------------------------------------------------- *

   oXbp := XbpQuickBrowse():new(oDlg:DrawingArea,,{0,0},oDlg:DrawingArea:CurrentSize() )
   oXbp:dataLink := DacPagedDataStore():new()
   oXbp:create()

   SetAppFocus( oXbp )

   nEvent := 0
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN

*
*
*